/**HEADER********************************************************************
* 
* Copyright (c) 2010 Avnet Japan Co.,Ltd (NIKE Borad Project.)
* All Rights Reserved
*
*************************************************************************** 
*
* $FileName: Shell_Task.c$
* $Version : 3.0.5.0$
* $Date    : Nov-21-2008$
*
* Comments:
*
*   
*
*END************************************************************************/



#include "NIKE_demo.h"


/* ------------------------------------------------------------------ 
   --- macro definition                                           --- 
   ------------------------------------------------------------------ */

#define MOUNT_PCM_FILESYSYTEM			1
#define MOUNT_PCM_FILESYSYTEM_FORMAT	1

/* ------------------------------------------------------------------ 
   --- variable definition                                        --- 
   ------------------------------------------------------------------ */

FILE_PTR                   pcm_dev_handle1;



/*TASK*-----------------------------------------------------------------
*
* Function Name  : Shell_Task
* Returned Value : void
* Comments       :
*
*END------------------------------------------------------------------*/

#if DEMOCFG_ENABLE_SERIAL_SHELL

void Shell_Task(uint_32 temp)
{ 
	FILE_PTR                   a_fd_ptr;
	int_32                     error_code;
	_mqx_uint                  mqx_status;

	a_fd_ptr = 0;
	printf("\n start Shell_Task\n");

	/* Open the device which MFS will be installed on */
	pcm_dev_handle1 = fopen("PCM:", 0);
	if ( pcm_dev_handle1 == NULL ) {
		printf("\nUnable to open Ramdisk device");
		_task_block();
	}

#if MOUNT_PCM_FILESYSYTEM
	/* Install MFS  */
	mqx_status = _io_mfs_install(pcm_dev_handle1, "a:", (_file_size)0);
	if (mqx_status != MFS_NO_ERROR) {
		printf("\nError initializing a:");
		_task_block();
	}
	else {
		printf("\nInitialized Ram Disk to a:\\");
	}

	/* Open the filesystem and format detect, if format is required */
	a_fd_ptr = fopen("a:", NULL);

	error_code    = ferror(a_fd_ptr);
	if ((error_code != MFS_NO_ERROR) && (error_code != MFS_NOT_A_DOS_DISK)){
		printf("\nError while opening a:\\ (%s)", MFS_Error_text((uint_32)(uint_32)error_code));
		_task_block();
	}

	if ( error_code == MFS_NOT_A_DOS_DISK ) {
		printf("\nNOT A DOS DISK! You must format to continue.");

#if MOUNT_PCM_FILESYSYTEM_FORMAT
		{
			uint_32                    error_code = IO_ERROR;
			char_ptr                   volume_ptr;
			volume_ptr = NULL;

			printf("\nFormating...\n");
			error_code = ioctl(a_fd_ptr, IO_IOCTL_DEFAULT_FORMAT,  NULL);
			if ( !error_code && volume_ptr) {
				error_code = ioctl(a_fd_ptr, IO_IOCTL_SET_VOLUME,  (pointer) volume_ptr);
			}

			if (error_code) {
				printf("Error while formatting: 0x%x\n", error_code);
			}
			else {
				/* print disk information */
				error_code = ioctl(a_fd_ptr, IO_IOCTL_GET_VOLUME, (uint_32_ptr) volume_ptr);
				printf("Done. Volume name is %s\nfree disk space: %lu bytes\n", volume_ptr, ioctl(a_fd_ptr, IO_IOCTL_FREE_SPACE, NULL) );
			}
		}
#endif

	}
#endif

	/* Run the shell on the serial port */
	for(;;)  {
		Shell(Shell_commands, NULL);
		printf("Shell exited, restarting...\n");
	}
}
#endif

/* EOF */
