#ifndef _qspicf_h
#define _qspicf_h 1
/**HEADER********************************************************************
* 
* Copyright (c) 2008 Freescale Semiconductor;
* All Rights Reserved
*
* Copyright (c) 2004-2008 Embedded Access Inc.;
* All Rights Reserved
*
* Copyright (c) 1989-2008 ARC International;
* All Rights Reserved
*
*************************************************************************** 
*
* THIS SOFTWARE IS PROVIDED BY FREESCALE "AS IS" AND ANY EXPRESSED OR 
* IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
* OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  
* IN NO EVENT SHALL FREESCALE OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, 
* INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES 
* (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR 
* SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) 
* HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, 
* STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING 
* IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF 
* THE POSSIBILITY OF SUCH DAMAGE.
*
**************************************************************************
*
* $FileName: qspi_mcf52xx.h$
* $Version : 3.0.3.0$
* $Date    : Apr-14-2009$
*
* Comments:
*
*   This file contains the definitions of constants and structures
*   required for the QSPI driver
*
*END************************************************************************/

/*--------------------------------------------------------------------------*/
/*
**                    DATATYPE DECLARATIONS
*/

/*
** MCF_QSPI_INIT_STRUCT
**
** This structure defines the initialization parameters to be used
** when a serial port is initialized.
*/
typedef struct mcf52xx_qspi_init_struct
{

   /* The clock speed of CPU */
//   uint_32 CLOCK_SPEED;

   /* The value for the frequency divider */
//   uint_32 QSPI_DIV;

   /* The QSPI speed */
   uint_32 BAUD_RATE;

   /* The maximum size of each receive */
   uint_32 RX_BUFFER_SIZE;

   /* The maximum size of each transmit */
   uint_32 TX_BUFFER_SIZE;

   /* The interrupt vector to use if interrupt driven */
   uint_32 VECTOR;

   /* The QSPI Chip Select */
   uint_32 CHIP_SELECT;

   /* The QSPI transfer mode (use some of definitions QSPI_TRANSFER_MODEx) */
   uint_32 TRANSFER_MODE;

} MCF52XX_QSPI_INIT_STRUCT, _PTR_ MCF52XX_QSPI_INIT_STRUCT_PTR;


/*--------------------------------------------------------------------------*/
/* 
**                        FUNCTION PROTOTYPES
*/

#ifdef __cplusplus
extern "C" {
#endif

extern uint_32 _mcf52xx_qspi_polled_install(char_ptr, pointer);
extern uint_32 _mcf52xx_qspi_int_install(char_ptr, pointer);

#ifdef __cplusplus
}
#endif

#endif

/* EOF */

